/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount } from '@solana/kit';
import { TOKEN_PROGRAM_ADDRESS } from '../programs';
export declare const CLOSE_ACCOUNT_DISCRIMINATOR = 9;
export declare function getCloseAccountDiscriminatorBytes(): import("@solana/kit").ReadonlyUint8Array;
export type CloseAccountInstruction<TProgram extends string = typeof TOKEN_PROGRAM_ADDRESS, TAccountAccount extends string | IAccountMeta<string> = string, TAccountDestination extends string | IAccountMeta<string> = string, TAccountOwner extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountAccount extends string ? WritableAccount<TAccountAccount> : TAccountAccount,
    TAccountDestination extends string ? WritableAccount<TAccountDestination> : TAccountDestination,
    TAccountOwner extends string ? ReadonlyAccount<TAccountOwner> : TAccountOwner,
    ...TRemainingAccounts
]>;
export type CloseAccountInstructionData = {
    discriminator: number;
};
export type CloseAccountInstructionDataArgs = {};
export declare function getCloseAccountInstructionDataEncoder(): Encoder<CloseAccountInstructionDataArgs>;
export declare function getCloseAccountInstructionDataDecoder(): Decoder<CloseAccountInstructionData>;
export declare function getCloseAccountInstructionDataCodec(): Codec<CloseAccountInstructionDataArgs, CloseAccountInstructionData>;
export type CloseAccountInput<TAccountAccount extends string = string, TAccountDestination extends string = string, TAccountOwner extends string = string> = {
    /** The account to close. */
    account: Address<TAccountAccount>;
    /** The destination account. */
    destination: Address<TAccountDestination>;
    /** The account's owner or its multisignature account. */
    owner: Address<TAccountOwner> | TransactionSigner<TAccountOwner>;
    multiSigners?: Array<TransactionSigner>;
};
export declare function getCloseAccountInstruction<TAccountAccount extends string, TAccountDestination extends string, TAccountOwner extends string, TProgramAddress extends Address = typeof TOKEN_PROGRAM_ADDRESS>(input: CloseAccountInput<TAccountAccount, TAccountDestination, TAccountOwner>, config?: {
    programAddress?: TProgramAddress;
}): CloseAccountInstruction<TProgramAddress, TAccountAccount, TAccountDestination, (typeof input)['owner'] extends TransactionSigner<TAccountOwner> ? ReadonlySignerAccount<TAccountOwner> & IAccountSignerMeta<TAccountOwner> : TAccountOwner>;
export type ParsedCloseAccountInstruction<TProgram extends string = typeof TOKEN_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The account to close. */
        account: TAccountMetas[0];
        /** The destination account. */
        destination: TAccountMetas[1];
        /** The account's owner or its multisignature account. */
        owner: TAccountMetas[2];
    };
    data: CloseAccountInstructionData;
};
export declare function parseCloseAccountInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedCloseAccountInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=closeAccount.d.ts.map