/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/kit';
import { ASSOCIATED_TOKEN_PROGRAM_ADDRESS } from '../programs';
export declare const CREATE_ASSOCIATED_TOKEN_DISCRIMINATOR = 0;
export declare function getCreateAssociatedTokenDiscriminatorBytes(): import("@solana/kit").ReadonlyUint8Array;
export type CreateAssociatedTokenInstruction<TProgram extends string = typeof ASSOCIATED_TOKEN_PROGRAM_ADDRESS, TAccountPayer extends string | IAccountMeta<string> = string, TAccountAta extends string | IAccountMeta<string> = string, TAccountOwner extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountAta extends string ? WritableAccount<TAccountAta> : TAccountAta,
    TAccountOwner extends string ? ReadonlyAccount<TAccountOwner> : TAccountOwner,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    ...TRemainingAccounts
]>;
export type CreateAssociatedTokenInstructionData = {
    discriminator: number;
};
export type CreateAssociatedTokenInstructionDataArgs = {};
export declare function getCreateAssociatedTokenInstructionDataEncoder(): Encoder<CreateAssociatedTokenInstructionDataArgs>;
export declare function getCreateAssociatedTokenInstructionDataDecoder(): Decoder<CreateAssociatedTokenInstructionData>;
export declare function getCreateAssociatedTokenInstructionDataCodec(): Codec<CreateAssociatedTokenInstructionDataArgs, CreateAssociatedTokenInstructionData>;
export type CreateAssociatedTokenAsyncInput<TAccountPayer extends string = string, TAccountAta extends string = string, TAccountOwner extends string = string, TAccountMint extends string = string, TAccountSystemProgram extends string = string, TAccountTokenProgram extends string = string> = {
    /** Funding account (must be a system account). */
    payer: TransactionSigner<TAccountPayer>;
    /** Associated token account address to be created. */
    ata?: Address<TAccountAta>;
    /** Wallet address for the new associated token account. */
    owner: Address<TAccountOwner>;
    /** The token mint for the new associated token account. */
    mint: Address<TAccountMint>;
    /** System program. */
    systemProgram?: Address<TAccountSystemProgram>;
    /** SPL Token program. */
    tokenProgram?: Address<TAccountTokenProgram>;
};
export declare function getCreateAssociatedTokenInstructionAsync<TAccountPayer extends string, TAccountAta extends string, TAccountOwner extends string, TAccountMint extends string, TAccountSystemProgram extends string, TAccountTokenProgram extends string, TProgramAddress extends Address = typeof ASSOCIATED_TOKEN_PROGRAM_ADDRESS>(input: CreateAssociatedTokenAsyncInput<TAccountPayer, TAccountAta, TAccountOwner, TAccountMint, TAccountSystemProgram, TAccountTokenProgram>, config?: {
    programAddress?: TProgramAddress;
}): Promise<CreateAssociatedTokenInstruction<TProgramAddress, TAccountPayer, TAccountAta, TAccountOwner, TAccountMint, TAccountSystemProgram, TAccountTokenProgram>>;
export type CreateAssociatedTokenInput<TAccountPayer extends string = string, TAccountAta extends string = string, TAccountOwner extends string = string, TAccountMint extends string = string, TAccountSystemProgram extends string = string, TAccountTokenProgram extends string = string> = {
    /** Funding account (must be a system account). */
    payer: TransactionSigner<TAccountPayer>;
    /** Associated token account address to be created. */
    ata: Address<TAccountAta>;
    /** Wallet address for the new associated token account. */
    owner: Address<TAccountOwner>;
    /** The token mint for the new associated token account. */
    mint: Address<TAccountMint>;
    /** System program. */
    systemProgram?: Address<TAccountSystemProgram>;
    /** SPL Token program. */
    tokenProgram?: Address<TAccountTokenProgram>;
};
export declare function getCreateAssociatedTokenInstruction<TAccountPayer extends string, TAccountAta extends string, TAccountOwner extends string, TAccountMint extends string, TAccountSystemProgram extends string, TAccountTokenProgram extends string, TProgramAddress extends Address = typeof ASSOCIATED_TOKEN_PROGRAM_ADDRESS>(input: CreateAssociatedTokenInput<TAccountPayer, TAccountAta, TAccountOwner, TAccountMint, TAccountSystemProgram, TAccountTokenProgram>, config?: {
    programAddress?: TProgramAddress;
}): CreateAssociatedTokenInstruction<TProgramAddress, TAccountPayer, TAccountAta, TAccountOwner, TAccountMint, TAccountSystemProgram, TAccountTokenProgram>;
export type ParsedCreateAssociatedTokenInstruction<TProgram extends string = typeof ASSOCIATED_TOKEN_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Funding account (must be a system account). */
        payer: TAccountMetas[0];
        /** Associated token account address to be created. */
        ata: TAccountMetas[1];
        /** Wallet address for the new associated token account. */
        owner: TAccountMetas[2];
        /** The token mint for the new associated token account. */
        mint: TAccountMetas[3];
        /** System program. */
        systemProgram: TAccountMetas[4];
        /** SPL Token program. */
        tokenProgram: TAccountMetas[5];
    };
    data: CreateAssociatedTokenInstructionData;
};
export declare function parseCreateAssociatedTokenInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedCreateAssociatedTokenInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=createAssociatedToken.d.ts.map