/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type WritableAccount } from '@solana/kit';
import { TOKEN_PROGRAM_ADDRESS } from '../programs';
export declare const INITIALIZE_ACCOUNT3_DISCRIMINATOR = 18;
export declare function getInitializeAccount3DiscriminatorBytes(): import("@solana/kit").ReadonlyUint8Array;
export type InitializeAccount3Instruction<TProgram extends string = typeof TOKEN_PROGRAM_ADDRESS, TAccountAccount extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountAccount extends string ? WritableAccount<TAccountAccount> : TAccountAccount,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    ...TRemainingAccounts
]>;
export type InitializeAccount3InstructionData = {
    discriminator: number;
    /** The new account's owner/multisignature. */
    owner: Address;
};
export type InitializeAccount3InstructionDataArgs = {
    /** The new account's owner/multisignature. */
    owner: Address;
};
export declare function getInitializeAccount3InstructionDataEncoder(): Encoder<InitializeAccount3InstructionDataArgs>;
export declare function getInitializeAccount3InstructionDataDecoder(): Decoder<InitializeAccount3InstructionData>;
export declare function getInitializeAccount3InstructionDataCodec(): Codec<InitializeAccount3InstructionDataArgs, InitializeAccount3InstructionData>;
export type InitializeAccount3Input<TAccountAccount extends string = string, TAccountMint extends string = string> = {
    /** The account to initialize. */
    account: Address<TAccountAccount>;
    /** The mint this account will be associated with. */
    mint: Address<TAccountMint>;
    owner: InitializeAccount3InstructionDataArgs['owner'];
};
export declare function getInitializeAccount3Instruction<TAccountAccount extends string, TAccountMint extends string, TProgramAddress extends Address = typeof TOKEN_PROGRAM_ADDRESS>(input: InitializeAccount3Input<TAccountAccount, TAccountMint>, config?: {
    programAddress?: TProgramAddress;
}): InitializeAccount3Instruction<TProgramAddress, TAccountAccount, TAccountMint>;
export type ParsedInitializeAccount3Instruction<TProgram extends string = typeof TOKEN_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The account to initialize. */
        account: TAccountMetas[0];
        /** The mint this account will be associated with. */
        mint: TAccountMetas[1];
    };
    data: InitializeAccount3InstructionData;
};
export declare function parseInitializeAccount3Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedInitializeAccount3Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=initializeAccount3.d.ts.map