/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type WritableAccount } from '@solana/kit';
import { TOKEN_PROGRAM_ADDRESS } from '../programs';
export declare const INITIALIZE_MULTISIG2_DISCRIMINATOR = 19;
export declare function getInitializeMultisig2DiscriminatorBytes(): import("@solana/kit").ReadonlyUint8Array;
export type InitializeMultisig2Instruction<TProgram extends string = typeof TOKEN_PROGRAM_ADDRESS, TAccountMultisig extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountMultisig extends string ? WritableAccount<TAccountMultisig> : TAccountMultisig,
    ...TRemainingAccounts
]>;
export type InitializeMultisig2InstructionData = {
    discriminator: number;
    /** The number of signers (M) required to validate this multisignature account. */
    m: number;
};
export type InitializeMultisig2InstructionDataArgs = {
    /** The number of signers (M) required to validate this multisignature account. */
    m: number;
};
export declare function getInitializeMultisig2InstructionDataEncoder(): Encoder<InitializeMultisig2InstructionDataArgs>;
export declare function getInitializeMultisig2InstructionDataDecoder(): Decoder<InitializeMultisig2InstructionData>;
export declare function getInitializeMultisig2InstructionDataCodec(): Codec<InitializeMultisig2InstructionDataArgs, InitializeMultisig2InstructionData>;
export type InitializeMultisig2Input<TAccountMultisig extends string = string> = {
    /** The multisignature account to initialize. */
    multisig: Address<TAccountMultisig>;
    m: InitializeMultisig2InstructionDataArgs['m'];
    signers: Array<Address>;
};
export declare function getInitializeMultisig2Instruction<TAccountMultisig extends string, TProgramAddress extends Address = typeof TOKEN_PROGRAM_ADDRESS>(input: InitializeMultisig2Input<TAccountMultisig>, config?: {
    programAddress?: TProgramAddress;
}): InitializeMultisig2Instruction<TProgramAddress, TAccountMultisig>;
export type ParsedInitializeMultisig2Instruction<TProgram extends string = typeof TOKEN_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The multisignature account to initialize. */
        multisig: TAccountMetas[0];
    };
    data: InitializeMultisig2InstructionData;
};
export declare function parseInitializeMultisig2Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedInitializeMultisig2Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=initializeMultisig2.d.ts.map